# メモ

masterブランチ    -> gem リリース最新版
developブランチ   -> 開発統合版
topicブランチ     -> Feature開発版



"XX since YYY" と since: time を同時に指定下場合は、前者が採用される (sinceオプションは無視される)。

### 時間の単位 (udunits)
    * years, year
    * months,month
    * days, day, d
    * hours, hour, h
    * minutes, minute, min
    * seconds, sec, s

### クラス構成

#### DateTime, DateTimeLikeクラス
	  class DateTime
      module ParseTimeStampExt  ### DateTime(-like)クラスに、`parse_timestamp`を追加する
	    module TimeStepsCustomExt ### TimeSteps用のDateTime refinement
	    extend ParseTimeStampExtension
    class DateTimeLike
      module DateTimeLikeExtension ### NoLeap,AllLeap,Fixed360共通のクラスメソッドを追加する
	  class DateTime::NoLeap < DateTimeLike
      extend  ParseTimeStampExtension
      extend  DateTimeLikeExtension
    class DateTime::AllLeap < DateTimeLike
      extend  ParseTimeStampExtension
      extend  DateTimeLikeExtension
    class DateTime::Fixed360Day < DateTimeLike
      extend  ParseTimeStampExtension
      extend  DateTimeLikeExtension

#### TimeStep, TimeStepsPair, TimeStepConverter クラス
    + class TimeSteps
	      using DateTime::TimeStepsCustomExt
    + class TimeSteps::Calendar
	      using DateTime::TimeStepsCustomExt	
    + class TimeStepsConv
	      using DateTime::TimeStepsCustomExt
        
### DateTimeのユリウス日の起算日
    -4712-01-01 00:00:00+00:00

### UDUnits-2との非互換性（CF-規約との非互換性）
    udunits-2は日にちの表式にBCを用いている。
      TimeSteps.newのbcオプションでparsingには対応しているものの、time_atなどで返されるDateTimeオブジェクトは
      BCを考慮していない点に注意。

    DateTime.parse_timestamp(spec, bc: true)
    TimeSteps#parse(spec)            (initialized with bc: option)
    TimeSteps::Calendar#parse(spec)  (initialized with bc: option)

### 暦の種類
#### standard, gregorian

* 今日使われているグレゴリオ暦 
* 1582年10月4日の翌日が1582年10月15日と
　することでユリウス暦で数えすぎたうるう日をスキップしている
* 1582年10月15日以降はグレゴリオ暦のうるう年ルールを採用
* 1582年10月4日以前はユリウス暦のうるう年ルールを採用

#### proleptic_gregorian

* 1582年10月15日以前もグレゴリオ暦のうるう年ルールを採用

#### proleptic_julian, julian

* 1582年10月4日以降もユリウス暦のうるう年ルールを採用

#### noleap, 365_day

* すべての年はうるう年ではないものとした暦

#### allleap, 366_day

* すべての年はうるう年であるとした暦

#### 360_day

* すべての月が30日であるとした暦


ts = TimeStep.new("6 hours since 2012-01-10 09:00:00")
ts = ts.shift_origin_with_days(-256.quo(24))










