class DateTime

  # datetime class represents `360_day` calendar
  #
  class Fixed360Day < DateTimeLike

    extend DateTimeLikeExtension

    # Number of days per year
    DPY = 360

    # Numbers of days per months
    DPM = [0,30,30,30,30,30,30,30,30,30,30,30,30]

    # Astronomical Julian day number of UNIX epoch
    UNIX_EPOCH_IN_AJD = Rational(4811039,2)

    def valid_date?
      if @day >= 31
        return false
      end
      if @month != 2
        return Date.valid_date?(@year, @month, @day)
      else
        return ( @day >= 1 and @day <= 30 )
      end
    end

    private :valid_date?

    def leap?
      raise NotImplementedError
    end
  
  end

end

