class DateTime

  # datetime class represents `allleap` or `366_day` calendar
  #
  class AllLeap < DateTimeLike

    extend DateTimeLikeExtension
  
    # Number of days per year
    DPY = 366

    # Numbers of days per months
    DPM = [0,31,29,31,30,31,30,31,31,30,31,30,31]

    # Astronomical Julian day number of UNIX epoch
    UNIX_EPOCH_IN_AJD = Rational(4891223,2)

    def valid_date?
      if @month != 2
        return Date.valid_date?(@year, @month, @day)
      else
        return ( @day >= 1 and @day <= 29 )
      end
    end

    private :valid_date?

    def leap?
      true
    end

  end

end