
class DateTime

  # datetime class represents `noleap` or `365_day` calendar
  #
  class NoLeap < DateTimeLike

    extend DateTimeLikeExtension
  
    # Number of days per year
    DPY = 365

    # Numbers of days per months
    DPM = [0,31,28,31,30,31,30,31,31,30,31,30,31]

    # Astronomical Julian day number of UNIX epoch
    UNIX_EPOCH_IN_AJD = Rational(4877859,2) 

    def valid_date?
      if @month != 2 
        return Date.valid_date?(@year, @month, @day)
      else
        return ( @day >= 1 and @day <= 28 )
      end
    end

    private :valid_date?

    def strftime (spec)
      DateTime.new(@year, @month, @day, @hour, @minute, @second, @offset).strftime(spec)
    end
  
    def leap?
      false
    end
  
  end

end