
class DateTime
  
  def timestep (interval_spec, tz: nil)
    case start
    when Date::ITALY
      calendar = "standard"
    when Date::GREGORIAN
      calendar = "proleptic_gregorian"
    when Date::JULIAN
      calendar = "proleptic_julian"
    end
    return TimeStep.new(interval_spec, since: self, calendar: calendar, tz: tz)
  end

  def timeperiod (interval_spec, tz: nil, ends: "[]")
    case start
    when Date::ITALY
      calendar = "standard"
    when Date::GREGORIAN
      calendar = "proleptic_gregorian"
    when Date::JULIAN
      calendar = "proleptic_julian"
    end
    return TimePeriod.new(interval_spec, since: self, calendar: calendar, ends: ends, tz: tz)
  end

end

class DateTime::NoLeap

  def timestep (interval_spec, tz: nil)
    return TimeStep.new(interval_spec, since: self, clanedar: "noleap", tz: tz)
  end  

  def timeperiod (interval_spec, tz: nil, ends: "[]")
    return TimePeriod.new(interval_spec, since: self, calendar: "noleap", ends: ends, tz: tz)
  end

end

class DateTime::AllLeap

  def timestep (interval_spec, tz: nil)
    return TimeStep.new(interval_spec, since: self, clanedar: "allleap", tz: tz)
  end  

  def timeperiod (interval_spec, tz: nil, ends: "[]")
    return TimePeriod.new(interval_spec, since: self, calendar: "allleap", ends: ends, tz: tz)
  end

end

class DateTime::Fixed360Day

  def timestep (interval_spec, tz: nil)
    return TimeStep.new(interval_spec, since: self, clanedar: "360day", tz: tz)
  end  

  def timeperiod (interval_spec, tz: nil, ends: "[]")
    return TimePeriod.new(interval_spec, since: self, calendar: "360day", ends: ends, tz: tz)
  end

end
